• Willkommen im Linux Club - dem deutschsprachigen Supportforum für GNU/Linux. Registriere dich kostenlos, um alle Inhalte zu sehen und Fragen zu stellen.

[HowTo] Logitech V500 an Laptop (getestet auf Suse 10.1)

BaXiM

Newbie
Grüße!

Diese HowTo basiert auf dem von stulle zur MX 1000 (http://www.linux-club.de/viewtopic.php?t=15176).

Ich betreibe eine Logitech V500 an meinem Laptop.
Für den vollen Funktionsumfang reicht es, evdev zu installieren und anschließend folgendes in xorg.conf einzutragen, bzw. einen bereits vorhandenen Eintrag zu verändern:

Code:
Section "InputDevice"
  Driver       "evdev"
  Identifier   "Mouse[3]"
  Option       "Buttons" "6"
  Option       "Device" "/dev/input/eventX"
  Option       "Name" "Logitech V500"
  Option       "Protocol" "explorerps/2"
  Option       "Vendor" "Sysp"
  Option       "ZAxisMapping" "4 5"
EndSection

Dabei ist eventX durch das von der Maus verwendete event-device zu ersetzen. (Siehe stulles HowTo für weitere Infos hierzu.)

Hier kann es jedoch Probleme geben, wenn die Maus beim Staten des X-Servers nicht angeschlossen ist. (Zumindest bei mir friert der X-Server ein und es ist nur noch ein Login über ssh von einem anderen Rechner aus möglich. Abziehen der Maus im laufendem Betrieb verursachte keine Probleme.) Um diesen Fall auszuschließen, habe ich ein Boot-Script geschrieben, dass überprüft, ob eine V500 angeschlossen ist und zwischen einer xorg.conf mit und einer ohne speziellen V500-Support auswählt.

Hierzu sind zwei zusätzliche Dateien in /etc/X11 nötig:
- xorg.conf.noV500 - eine Kopie der unveränderten xorg.conf (also ohne evdev)
- xorg.conf.V500 - eine Kopie von xorg.conf, die folgendes enthält:

Code:
Section "InputDevice"
  Driver       "evdev"
  Identifier   "Mouse[3]"
  Option       "Buttons" "6"
  Option       "Device" "/dev/input/sedreplace"
  Option       "Name" "Logitech V500"
  Option       "Protocol" "explorerps/2"
  Option       "Vendor" "Sysp"
  Option       "ZAxisMapping" "4 5"
EndSection

Das "sedreplace" darf im Gegensatz zu eventX oben NICHT durch ein event-device ersetzt werden. Dies erledigt das Boot-Script später automatisch.
Anschließend folgendes Skript in /etc/init.d hinzufügen:
Code:
#!/bin/bash

### BEGIN INIT INFO
# Provides:          boot.checkV500
# Required-Start:    boot.cryptomount boot.device-mapper boot.localfs boot.loadmodules boot.proc boot.ldconfig
# Should-Start: 
# Required-Stop:     
# Should-Stop: 
# Default-Start:     B
# Default-Stop:      
# Short-Description: Check for Logitech V500 befor X-Server is started
# Description:       Checks, if Logitech V500 is found, before X-Server
#	is started. Depending on result copies either 'xorg.conf.noV500'
#	or 'xorg.conf.V500' over 'xorg.conf', which is backuped to
#	'xorg.conf.last'. Necessary to prevent X-Server hangup due to
#	non-present V500.
### END INIT INFO
# 
# Any extensions to the keywords given above should be preceeded by 
# X-VendorTag- (X-UnitedLinux- X-SuSE- for us) according to LSB.
# 
# Notes on Required-Start/Should-Start:
# * There are two different issues that are solved by Required-Start
#    and Should-Start
# (a) Hard dependencies: This is used by the runlevel editor to determine
#     which services absolutely need to be started to make the start of
#     this service make sense. Example: nfsserver should have
#     Required-Start: $portmap
#     Also, required services are started before the dependent ones.
#     The runlevel editor will warn about such missing hard dependencies
#     and suggest enabling. During system startup, you may expect an error,
#     if the dependency is not fulfilled.
# (b) Specifying the init script ordering, not real (hard) dependencies.
#     This is needed by insserv to determine which service should be
#     started first (and at a later stage what services can be started
#     in parallel). The tag Should-Start: is used for this.
#     It tells, that if a service is available, it should be started
#     before. If not, never mind.
# * When specifying hard dependencies or ordering requirements, you can 
#   use names of services (contents of their Provides: section)
#   or pseudo names starting with a $. The following ones are available
#   according to LSB (1.1):
#	$local_fs		all local file systems are mounted
#				(most services should need this!)
#	$remote_fs		all remote file systems are mounted
#				(note that /usr may be remote, so
#				 many services should Require this!)
#	$syslog			system logging facility up
#	$network		low level networking (eth card, ...)
#	$named			hostname resolution available
#	$netdaemons		all network daemons are running
#   The $netdaemons pseudo service has been removed in LSB 1.2.
#   For now, we still offer it for backward compatibility.
#   These are new (LSB 1.2):
#	$time			the system time has been set correctly	
#	$portmap		SunRPC portmapping service available
#   UnitedLinux extensions:
#	$ALL			indicates that a script should be inserted
#				at the end
# * The services specified in the stop tags 
#   (Required-Stop/Should-Stop)
#   specify which services need to be still running when this service
#   is shut down. Often the entries there are just copies or a subset 
#   from the respective start tag.
# * Should-Start/Stop are now part of LSB as of 2.0,
#   formerly SUSE/Unitedlinux used X-UnitedLinux-Should-Start/-Stop.
#   insserv does support both variants.
# * X-UnitedLinux-Default-Enabled: yes/no is used at installation time
#   (%fillup_and_insserv macro in %post of many RPMs) to specify whether
#   a startup script should default to be enabled after installation.
#   It's not used by insserv.
#
# Note on runlevels:
# 0 - halt/poweroff 			6 - reboot
# 1 - single user			2 - multiuser without network exported
# 3 - multiuser w/ network (text mode)  5 - multiuser w/ network and X11 (xdm)
# 
# Note on script names:
# http://www.linuxbase.org/spec/refspecs/LSB_1.3.0/gLSB/gLSB/scrptnames.html
# A registry has been set up to manage the init script namespace.
# http://www.lanana.org/
# Please use the names already registered or register one or use a
# vendor prefix.

# Check for existence of needed config files
FILEPATH=/etc/X11
XORG=$FILEPATH/xorg.conf
V500=$FILEPATH/xorg.conf.V500
noV500=$FILEPATH/xorg.conf.noV500
LAST=$FILEPATH/xorg.conf.last

test -r $XORG || { echo "$XORG not existing";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 6; fi; }

test -r $V500 || { echo "$noV500 not existing";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 6; fi; }

test -r $noV500 || { echo "$noV500 not existing";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 6; fi; }

# Source LSB init functions
# providing start_daemon, killproc, pidofproc, 
# log_success_msg, log_failure_msg and log_warning_msg.
# This is currently not used by UnitedLinux based distributions and
# not needed for init scripts for UnitedLinux only. If it is used,
# the functions from rc.status should not be sourced or used.
#. /lib/lsb/init-functions

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     be verbose in local rc status and clear it afterwards
#      rc_status -v -r  ditto and clear both the local and overall rc status
#      rc_status -s     display "skipped" and exit with status 3
#      rc_status -u     display "unused" and exit with status 3
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num>
#      rc_reset         clear both the local and overall rc status
#      rc_exit          exit appropriate to overall rc status
#      rc_active        checks whether a service is activated by symlinks
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

case "$1" in
    start)
	echo "Checking for Logitech V500"
	#See, if there is a LT V500 present
	handlerline=`cat /proc/bus/input/devices | grep -A 4 "Bus=0003 Vendor=046d Product=c510 Version=3410" | \
	 grep "H: "`
	if [ "$?" == "0" ];then
            #Get event-number
	    if [ "${handlerline:$(( -7 )):5}" == "event" ];then
		eventnum=${handlerline:$(( -2 )):1}
		echo "Found Logitech V500 with event$eventnum."
		V500ok=yes
		if [ "$eventnum" != "3" ];then V500ok=no;fi
	    else
		echo -n "Logitech V500 was found, but event-number could not be deteminated."
		V500ok=no
	    fi
	else
	    echo -n "Logitech V500 not found."
	    V500ok=no
	fi

        #Make Backup of existing xorg.conf and replace it
	cp --preserve=all $XORG $LAST
	if [ "$V500ok" == "yes" ];then
	    cat $V500 | sed "s/\"\/dev\/input\/sedreplace\"/\"\/dev\/input\/event${eventnum}\"/g" > $XORG 
	else
	    cp --preserve=all $noV500 $XORG
	fi

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    status)
	echo "Checking for checkV500 ..."
	echo -n "No use asking, since it is a "run-once" script "
	;;
    *)
	echo "Usage: $0 {start|stop|status|restart}"
	exit 1
	;;
esac
rc_exit

Eventuell ist noch /etc/init.d/.depends.boot um den Eintrag "boot.checkV500" gleich in der ersten Zeile und um die Zeile
Code:
boot.checkV500: boot.localfs boot.device-mapper boot.cryptomount boot.loadmodules boot.proc boot.ldconfig
zu erweitern.

Abschließend nur noch zwei Symlinks in /etc/init.d/boot.d erstellen.
Code:
ln -s /etc/init.d/boot.checkV500 /etc/init.d/boot.d/S13boot.checkV500
ln -s /etc/init.d/boot.checkV500 /etc/init.d/boot.d/K13boot.checkV500

Fertig!


Was genau tut das Script?

Es überprüft bei jedem Aufruf, ob es eine LT V500 finden kann und ermittelt deren event-device.
Anschließend macht es ein Backup der vorhandenen xorg.conf als xorg.conf.last und kopiert xorg.conf.V500 nach xorg.conf.
Hierbei wird "sedreplace" durch das event-device der Maus ersetzt.
Wird keine LT V500 gefunden, so werden xorg.conf nach xorg.conf.last und xorg.conf.noV500 nach xorg.conf kopiert.
 

Oli-nux

Hacker
Mal als Wichtig markiert und oben "angepinnt".;)

Fragen zum Script hier rein - für Probleme auf eurem Laptop bitte extra Thread erstellen!:)
 
Oben